euroFormat=(tonumber("1,000")==1); -- redundant but harmless

equipmentLayout={}
function UseDefaultLayout(left,top)
	if left==nil or left<147 then left=147 end
	if top==nil or top<0 then top=50 end
	if equipmentLayout==nil then
		equipmentLayout={}
	else
		while #equipmentLayout>0 do
			table.remove(equipmentLayout);
		end
	end

	equipmentLayout[0]={left,top};
	equipmentLayout[0].background=0x41007e95;
	equipmentLayout[0].Text="Mannequin";
	equipmentLayout[0].Class=Turbine.Gameplay.Equipment.Undefined; -- should be same as index...
	equipmentLayout[1]={equipmentLayout[0][1]+149,equipmentLayout[0][2]-30};
	equipmentLayout[1].background=0x41007eed;
	equipmentLayout[1].Text="Head Slot";
	equipmentLayout[1].Class=Turbine.Gameplay.Equipment.Head;
	equipmentLayout[2]={equipmentLayout[0][1]+149,equipmentLayout[0][2]+16};
	equipmentLayout[2].background=0x41007ef0;
	equipmentLayout[2].Text="Chest Slot";
	equipmentLayout[2].Class=Turbine.Gameplay.Equipment.Chest;
	equipmentLayout[3]={equipmentLayout[0][1]+149,equipmentLayout[0][2]+108};
	equipmentLayout[3].background=0x41007ef1;
	equipmentLayout[3].Text="Legs Slot";
	equipmentLayout[3].Class=Turbine.Gameplay.Equipment.Legs;
	equipmentLayout[4]={equipmentLayout[0][1]+149,equipmentLayout[0][2]+62};
	equipmentLayout[4].background=0x41007ef2;
	equipmentLayout[4].Text="Gloves Slot";
	equipmentLayout[4].Class=Turbine.Gameplay.Equipment.Gloves;
	equipmentLayout[5]={equipmentLayout[0][1]+203,equipmentLayout[0][2]+108};
	equipmentLayout[5].background=0x41007ef5;
	equipmentLayout[5].Text="Boots Slot";
	equipmentLayout[5].Class=Turbine.Gameplay.Equipment.Boots;
	equipmentLayout[6]={equipmentLayout[0][1]+203,equipmentLayout[0][2]-30};
	equipmentLayout[6].background=0x41007eee;
	equipmentLayout[6].Text="Shoulder Slot";
	equipmentLayout[6].Class=Turbine.Gameplay.Equipment.Shoulder;
	equipmentLayout[7]={equipmentLayout[0][1]+203,equipmentLayout[0][2]+16};
	equipmentLayout[7].background=0x41007ee9;
	equipmentLayout[7].Text="Back Slot";
	equipmentLayout[7].Class=Turbine.Gameplay.Equipment.Back;
	equipmentLayout[8]={equipmentLayout[0][1]-138,equipmentLayout[0][2]+62};
	equipmentLayout[8].background=0x41007ef8;
	equipmentLayout[8].Text="Left Bracelet Slot";
	equipmentLayout[8].Class=Turbine.Gameplay.Equipment.Bracelet1;
	equipmentLayout[9]={equipmentLayout[0][1]-84,equipmentLayout[0][2]+62};
	equipmentLayout[9].background=0x41007ef9;
	equipmentLayout[9].Text="Right Bracelet Slot";
	equipmentLayout[9].Class=Turbine.Gameplay.Equipment.Bracelet2;
	equipmentLayout[10]={equipmentLayout[0][1]-138,equipmentLayout[0][2]+16};
	equipmentLayout[10].background=0x41007eef;
	equipmentLayout[10].Text="Necklace Slot";
	equipmentLayout[10].Class=Turbine.Gameplay.Equipment.Necklace;
	equipmentLayout[11]={equipmentLayout[0][1]-138,equipmentLayout[0][2]+108};
	equipmentLayout[11].background=0x41007ef3;
	equipmentLayout[11].Text="Left Ring Slot";
	equipmentLayout[11].Class=Turbine.Gameplay.Equipment.Ring1;
	equipmentLayout[12]={equipmentLayout[0][1]-84,equipmentLayout[0][2]+108};
	equipmentLayout[12].background=0x41007ef4;
	equipmentLayout[12].Text="Right Ring Slot";
	equipmentLayout[12].Class=Turbine.Gameplay.Equipment.Ring2;
	equipmentLayout[13]={equipmentLayout[0][1]-138,equipmentLayout[0][2]-30};
	equipmentLayout[13].background=0x41007ef6;
	equipmentLayout[13].Text="Left Ear Slot";
	equipmentLayout[13].Class=Turbine.Gameplay.Equipment.Earring1;
	equipmentLayout[14]={equipmentLayout[0][1]-84,equipmentLayout[0][2]-30};
	equipmentLayout[14].background=0x41007ef7;
	equipmentLayout[14].Text="Right Ear Slot";
	equipmentLayout[14].Class=Turbine.Gameplay.Equipment.Earring2;
	equipmentLayout[15]={equipmentLayout[0][1]-84,equipmentLayout[0][2]+16};
	equipmentLayout[15].background=0x41007efa;
	equipmentLayout[15].Text="Pocket Slot";
	equipmentLayout[15].Class=Turbine.Gameplay.Equipment.Pocket;
	equipmentLayout[16]={equipmentLayout[0][1]-74,equipmentLayout[0][2]+182};
	equipmentLayout[16].background=0x41007eea;
	equipmentLayout[16].Text="Primary Weapon Slot";
	equipmentLayout[16].Class=Turbine.Gameplay.Equipment.PrimaryWeapon;
	equipmentLayout[17]={equipmentLayout[0][1]-20,equipmentLayout[0][2]+182};
	equipmentLayout[17].background=0x41007eeb;
	equipmentLayout[17].Text="Secondart Weapon/Shield Slot";
	equipmentLayout[17].Class=Turbine.Gameplay.Equipment.SecondaryWeapon;
	equipmentLayout[18]={equipmentLayout[0][1]+34,equipmentLayout[0][2]+182};
	equipmentLayout[18].background=0x41007eec;
	equipmentLayout[18].Text="Ranged Weapon/Instrument Slot";
	equipmentLayout[18].Class=Turbine.Gameplay.Equipment.RangedWeapon;
	equipmentLayout[19]={equipmentLayout[0][1]+88,equipmentLayout[0][2]+182};
	equipmentLayout[19].background=0x41007efb;
	equipmentLayout[19].Text="Craft Slot";
	equipmentLayout[19].Class=Turbine.Gameplay.Equipment.CraftTool;
	equipmentLayout[20]={equipmentLayout[0][1]+142,equipmentLayout[0][2]+182};
	equipmentLayout[20].background=0x410e8680;
	equipmentLayout[20].Text="Class Slot";
	equipmentLayout[20].Class=Turbine.Gameplay.Equipment.Class;
end

function LoadEquippedItemsData()
	-- load saved settings
	equipmentLayout=PatchDataLoad( Turbine.DataScope.Account, "AltInventory_EquipmentLayout");
end
LoadEquippedItemsData()
if equipmentLayout==nil then
	UseDefaultLayout();
end

--Turbine.Shell.WriteLine(#equipmentLayout)
--Turbine.Shell.WriteLine(equipmentLayout[0][1])

EquippedItemsPanel=class(Turbine.UI.Control)
function EquippedItemsPanel:Constructor()
	Turbine.UI.Control.Constructor(self)
	self:SetMouseVisible(false);

--self:SetBackColor(Turbine.UI.Color(0,.5,1));
	self:SetVisible(false);
	self:SetSize(200,200);
	self.oldWidth=0;
	self.oldHeight=0;
	self.characterIndex=1;
	local charIndex;
	for charIndex=1,#characterListArray do
		if characterListArray[charIndex][1]==currentCharacterName then
			self.characterIndex=charIndex;
			break;
		end
	end

	self.Backdrop=Turbine.UI.Control();
	self.Backdrop:SetParent(self);
	self.Backdrop:SetBackColor(Turbine.UI.Color(1,0,0,0));
	self.Backdrop:SetSize(self:GetWidth(),self:GetHeight());

	self.MoveControlPanel=Turbine.UI.Control();
	self.MoveControlPanel:SetParent(self);
	self.MoveControlPanel:SetZOrder(100);-- force semi-topmost
	self.MoveControlPanel:SetSize(self:GetWidth(),22);
	self.MoveControlPanel:SetMouseVisible(false);

	self.MoveXCoord=Turbine.UI.Label();
	self.MoveXCoord:SetParent(self.MoveControlPanel);
	self.MoveXCoord:SetForeColor(Turbine.UI.Color(1,1,1));
	self.MoveXCoord:SetFont(Turbine.UI.Lotro.Font.Verdana18);
	self.MoveXCoord:SetSize(90,20);
	self.MoveXCoord:SetPosition(1,1);
	self.MoveXCoord:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.MoveXCoord:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.MoveXCoord:SetVisible(false);
	self.MoveXCoord:SetMultiline(false);
	self.MoveXCoord:SetMouseVisible(false);

	self.MoveYCoord=Turbine.UI.Label();
	self.MoveYCoord:SetParent(self.MoveControlPanel);
	self.MoveYCoord:SetForeColor(Turbine.UI.Color(1,1,1));
	self.MoveYCoord:SetFont(Turbine.UI.Lotro.Font.Verdana18);
	self.MoveYCoord:SetSize(90,20);
	self.MoveYCoord:SetPosition(100,1);
	self.MoveYCoord:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.MoveYCoord:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.MoveYCoord:SetVisible(false);
	self.MoveYCoord:SetMultiline(false);
	self.MoveYCoord:SetMouseVisible(false);

	self.MoveUseDefault=Turbine.UI.Lotro.Button()
	self.MoveUseDefault:SetParent(self.MoveControlPanel);
	self.MoveUseDefault:SetText(Resource[language][302]);
	self.MoveUseDefault:SetSize(100,20);
	self.MoveUseDefault:SetPosition((self:GetWidth()-100)/2,1);
	self.MoveUseDefault.MouseClick=function()
		UseDefaultLayout((self:GetWidth()-110)/2,50);
		self.Mannequin:SetPosition(equipmentLayout[0][1],equipmentLayout[0][2]);
		local tmpIndex
		for tmpIndex=1, 20 do
			self.ItemSlot[tmpIndex]:SetPosition(equipmentLayout[tmpIndex][1],equipmentLayout[tmpIndex][2]);
		end
	end

	self.HoverInfo=Turbine.UI.ContextMenu();
	self.HoverInfo:GetItems():Add(Turbine.UI.MenuItem(""));
	self.HoverInfo:GetItems():Get(1):SetEnabled(false);


	self.ItemSlot={}
	for tmpIndex=1, 20 do
		self.ItemSlot[tmpIndex]=Turbine.UI.Control();
		self.ItemSlot[tmpIndex]:SetParent(self);
		self.ItemSlot[tmpIndex]:SetSize(44,44);
		self.ItemSlot[tmpIndex]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
		self.ItemSlot[tmpIndex].MoveY=-1;
		self.ItemSlot[tmpIndex].MoveX=-1;
		self.ItemSlot[tmpIndex]:SetPosition(equipmentLayout[tmpIndex][1],equipmentLayout[tmpIndex][2]);
		self.ItemSlot[tmpIndex]:SetBackground(equipmentLayout[tmpIndex].background);
		self.ItemSlot[tmpIndex].Text=equipmentLayout[tmpIndex].Text;
		self.ItemSlot[tmpIndex].Index=tmpIndex;

		self.ItemSlot[tmpIndex].BackgroundImage=Turbine.UI.Control()
		self.ItemSlot[tmpIndex].BackgroundImage:SetParent(self.ItemSlot[tmpIndex]);
		self.ItemSlot[tmpIndex].BackgroundImage:SetSize(32,32);
		self.ItemSlot[tmpIndex].BackgroundImage:SetPosition(6,6);
		self.ItemSlot[tmpIndex].BackgroundImage:SetMouseVisible(false);
		self.ItemSlot[tmpIndex].BackgroundImage:SetBlendMode(Turbine.UI.BlendMode.Overlay);
		self.ItemSlot[tmpIndex].Image=Turbine.UI.Control()
		self.ItemSlot[tmpIndex].Image:SetParent(self.ItemSlot[tmpIndex]);
		self.ItemSlot[tmpIndex].Image:SetSize(32,32);
		self.ItemSlot[tmpIndex].Image:SetPosition(6,6);
		self.ItemSlot[tmpIndex].Image:SetMouseVisible(false);
		self.ItemSlot[tmpIndex].Image:SetBlendMode(Turbine.UI.BlendMode.Overlay);

--		self.ItemSlot[tmpIndex].Slot=Turbine.UI.Lotro.EquipmentSlot(); -- we never set the parent so that the slot doesn't actually display, we just want it for the events
--		self.ItemSlot[tmpIndex].Slot:SetEquipmentSlot(equipmentLayout[tmpIndex].Class);

		self.ItemSlot[tmpIndex].MouseDown=function(target,args)
			if target:IsControlKeyDown() and args.Button==1 then
				target.MoveX=args.X;
				target.MoveY=args.Y;
				self.MoveXCoord:SetText("X: "..equipmentLayout[target.Index][1]);
				self.MoveYCoord:SetText("Y: "..equipmentLayout[target.Index][2]);
				self.MoveXCoord:SetVisible(true);
				self.MoveYCoord:SetVisible(true);
			end
		end
		self.ItemSlot[tmpIndex].MouseHover=function(target,args)
			local name=target.Name;
			if name~=nil then
				self.HoverInfo:GetItems():Get(1):SetText(name);
				self.HoverInfo:ShowMenu();
			end
		end
		self.ItemSlot[tmpIndex].MouseUp=function(target,args)
			target.MoveX=-1;
			target.MoveY=-1;
			self.MoveXCoord:SetVisible(false);
			self.MoveYCoord:SetVisible(false);
		end
		self.ItemSlot[tmpIndex].MouseMove=function(target,args)
			if target.MoveX~=-1 and (args.X~=target.MoveX or args.Y~= target.MoveY) then
				local newLeft=target:GetLeft()-(target.MoveX-args.X)
				local newTop=target:GetTop()-(target.MoveY-args.Y)
				if newLeft<0 then newLeft=0 end;
				if newLeft>(self:GetWidth()-target:GetWidth()) then newLeft=self:GetWidth()-target:GetWidth() end;
				if newTop<0 then newTop=0 end;
				if newTop>(self:GetHeight()-target:GetHeight()) then newTop=self:GetHeight()-target:GetHeight() end;
				equipmentLayout[target.Index][1]=newLeft;
				equipmentLayout[target.Index][2]=newTop;
				target:SetPosition(newLeft,newTop);
				self.MoveXCoord:SetText("X: "..newLeft);
				self.MoveYCoord:SetText("Y: "..newTop);
			end
		end

		self.ItemSlot[tmpIndex].MouseClick = function(target,args)
			target.MoveX=-1;
			self.MoveXCoord:SetVisible(false);
			self.MoveYCoord:SetVisible(false);
		end
	end

	self.Mannequin=Turbine.UI.Control();
	self.Mannequin:SetParent(self);
	self.Mannequin:SetPosition(equipmentLayout[0][1],equipmentLayout[0][2]);
	self.Mannequin:SetBackground(equipmentLayout[0].background);
	self.Mannequin:SetSize(110,148);
	self.Mannequin:SetBlendMode(5);

	self.Mannequin.MoveX=-1;
	self.Mannequin.MoveY=-1;
	self.Mannequin.MouseDown=function(target,args)
		if target:IsControlKeyDown() and args.Button==1 then
			target.MoveX=args.X;
			target.MoveY=args.Y;
			self.MoveXCoord:SetText("X: "..equipmentLayout[0][1]);
			self.MoveYCoord:SetText("Y: "..equipmentLayout[0][2]);
			self.MoveXCoord:SetVisible(true);
			self.MoveYCoord:SetVisible(true);
		end
	end
	self.Mannequin.MouseUp=function(target,args)
		target.MoveX=-1;
		target.MoveY=-1;
		self.MoveXCoord:SetVisible(false);
		self.MoveYCoord:SetVisible(false);
	end
	self.Mannequin.MouseMove=function(target,args)
		if target.MoveX~=-1 and (args.X~=target.MoveX or args.Y~= target.MoveY) then
			local newLeft=target:GetLeft()-(target.MoveX-args.X)
			local newTop=target:GetTop()-(target.MoveY-args.Y)
			if newLeft<0 then newLeft=0 end;
			if newLeft>(self:GetWidth()-target:GetWidth()) then newLeft=self:GetWidth()-target:GetWidth() end;
			if newTop<0 then newTop=0 end;
			if newTop>(self:GetHeight()-target:GetHeight()) then newTop=self:GetHeight()-target:GetHeight() end;
			local hOffset,vOffset=newLeft-equipmentLayout[0][1],newTop-equipmentLayout[0][2];
			local itemIndex;
			for itemIndex=1,#self.ItemSlot do
				self.ItemSlot[itemIndex]:SetLeft(self.ItemSlot[itemIndex]:GetLeft()+hOffset);
				self.ItemSlot[itemIndex]:SetTop(self.ItemSlot[itemIndex]:GetTop()+vOffset);
			end
			equipmentLayout[0][1]=newLeft;
			equipmentLayout[0][2]=newTop;
			target:SetPosition(newLeft,newTop);
			self.MoveXCoord:SetText("X: "..newLeft);
			self.MoveYCoord:SetText("Y: "..newTop);
		end
	end
	self.Mannequin.MouseClick = function(target,args)
		target.MoveX=-1;
		self.MoveXCoord:SetVisible(false);
		self.MoveYCoord:SetVisible(false);
	end

	self.Mannequin.Head=Turbine.UI.Control();
	self.Mannequin.Head:SetParent(self.Mannequin);
	self.Mannequin.Head:SetPosition(0,0);
	self.Mannequin.Head:SetBackground(0x41007e96);
	self.Mannequin.Head:SetSize(110,148);
	self.Mannequin.Head:SetBackColor(Turbine.UI.Color(.7,0,.8,0));
	self.Mannequin.Head:SetBlendMode(4);
	self.Mannequin.Head:SetBackColorBlendMode(1); -- 6
	self.Mannequin.Head:SetStretchMode(1); -- assigning mode 1 or 3 allows the image to blend with it's backcolor but overlay the image below (it's color doesn't affect the compound image)
	self.Mannequin.Head:SetMouseVisible(false);

	self.Mannequin.Chest=Turbine.UI.Control();
	self.Mannequin.Chest:SetParent(self.Mannequin);
	self.Mannequin.Chest:SetPosition(0,0);
	self.Mannequin.Chest:SetBackground(0x41007e97);
	self.Mannequin.Chest:SetSize(110,148);
	self.Mannequin.Chest:SetBackColor(Turbine.UI.Color(.7,0,.8,0));
	self.Mannequin.Chest:SetBlendMode(4);
	self.Mannequin.Chest:SetBackColorBlendMode(1); -- 6
	self.Mannequin.Chest:SetStretchMode(1);
	self.Mannequin.Chest:SetMouseVisible(false);

	self.Mannequin.Legs=Turbine.UI.Control();
	self.Mannequin.Legs:SetParent(self.Mannequin);
	self.Mannequin.Legs:SetPosition(0,0);
	self.Mannequin.Legs:SetBackground(0x41007e98);
	self.Mannequin.Legs:SetSize(110,148);
	self.Mannequin.Legs:SetBackColor(Turbine.UI.Color(.7,0,.8,0));
	self.Mannequin.Legs:SetBlendMode(4);
	self.Mannequin.Legs:SetBackColorBlendMode(1); -- 6
	self.Mannequin.Legs:SetStretchMode(1);
	self.Mannequin.Legs:SetMouseVisible(false);

	self.Mannequin.Wrist=Turbine.UI.Control();
	self.Mannequin.Wrist:SetParent(self.Mannequin);
	self.Mannequin.Wrist:SetPosition(0,0);
	self.Mannequin.Wrist:SetBackground(0x41007e99);
	self.Mannequin.Wrist:SetSize(110,148);
	self.Mannequin.Wrist:SetBackColor(Turbine.UI.Color(.7,0,.8,0));
	self.Mannequin.Wrist:SetBlendMode(4);
	self.Mannequin.Wrist:SetBackColorBlendMode(1); -- 6
	self.Mannequin.Wrist:SetStretchMode(1);
	self.Mannequin.Wrist:SetMouseVisible(false);

	self.Mannequin.Boot=Turbine.UI.Control();
	self.Mannequin.Boot:SetParent(self.Mannequin);
	self.Mannequin.Boot:SetPosition(0,0);
	self.Mannequin.Boot:SetBackground(0x41007e9a);
	self.Mannequin.Boot:SetSize(110,148);
	self.Mannequin.Boot:SetBackColor(Turbine.UI.Color(.7,0,.8,0));
	self.Mannequin.Boot:SetBlendMode(4);
	self.Mannequin.Boot:SetBackColorBlendMode(1); -- 6
	self.Mannequin.Boot:SetStretchMode(1);
	self.Mannequin.Boot:SetMouseVisible(false);

	self.Mannequin.Cape=Turbine.UI.Control();
	self.Mannequin.Cape:SetParent(self.Mannequin);
	self.Mannequin.Cape:SetPosition(0,0);
	self.Mannequin.Cape:SetBackground(0x41007e9b);
	self.Mannequin.Cape:SetSize(110,148);
	self.Mannequin.Cape:SetBackColor(Turbine.UI.Color(.7,0,.8,0));
	self.Mannequin.Cape:SetBlendMode(4);
	self.Mannequin.Cape:SetBackColorBlendMode(1); -- 6
	self.Mannequin.Cape:SetStretchMode(1);
	self.Mannequin.Cape:SetMouseVisible(false);

	self.Mannequin.Shoulder=Turbine.UI.Control();
	self.Mannequin.Shoulder:SetParent(self.Mannequin);
	self.Mannequin.Shoulder:SetPosition(0,0);
	self.Mannequin.Shoulder:SetBackground(0x41007e9c);
	self.Mannequin.Shoulder:SetSize(110,148);
	self.Mannequin.Shoulder:SetBackColor(Turbine.UI.Color(.7,0,.8,0));
	self.Mannequin.Shoulder:SetBlendMode(4);
	self.Mannequin.Shoulder:SetBackColorBlendMode(1); -- 6
	self.Mannequin.Shoulder:SetStretchMode(1);
	self.Mannequin.Shoulder:SetMouseVisible(false);

	self.Mannequin.Main=Turbine.UI.Control();
	self.Mannequin.Main:SetParent(self.Mannequin);
	self.Mannequin.Main:SetPosition(0,0);
	self.Mannequin.Main:SetBackground(0x41007e9d);
	self.Mannequin.Main:SetSize(110,148);
	self.Mannequin.Main:SetBackColor(Turbine.UI.Color(.7,0,.8,0));
	self.Mannequin.Main:SetBlendMode(4);
	self.Mannequin.Main:SetBackColorBlendMode(1); -- 6
	self.Mannequin.Main:SetStretchMode(1);
	self.Mannequin.Main:SetMouseVisible(false);

	self.Mannequin.Secondary=Turbine.UI.Control();
	self.Mannequin.Secondary:SetParent(self.Mannequin);
	self.Mannequin.Secondary:SetPosition(0,0);
	self.Mannequin.Secondary:SetBackground(0x41007e9e);
	self.Mannequin.Secondary:SetSize(110,148);
	self.Mannequin.Secondary:SetBackColor(Turbine.UI.Color(.7,0,.8,0));
	self.Mannequin.Secondary:SetBlendMode(4);
	self.Mannequin.Secondary:SetBackColorBlendMode(1); -- 6
	self.Mannequin.Secondary:SetStretchMode(1);
	self.Mannequin.Secondary:SetMouseVisible(false);

	self.Mannequin.Ranged=Turbine.UI.Control();
	self.Mannequin.Ranged:SetParent(self.Mannequin);
	self.Mannequin.Ranged:SetPosition(0,0);
	self.Mannequin.Ranged:SetBackground(0x41007e9f);
	self.Mannequin.Ranged:SetSize(110,148);
	self.Mannequin.Ranged:SetBackColor(Turbine.UI.Color(.7,0,.8,0));
	self.Mannequin.Ranged:SetBlendMode(4);
	self.Mannequin.Ranged:SetBackColorBlendMode(1); -- 6
	self.Mannequin.Ranged:SetStretchMode(1);
	self.Mannequin.Ranged:SetMouseVisible(false);

	self.Mannequin.Craft=Turbine.UI.Control();
	self.Mannequin.Craft:SetParent(self.Mannequin);
	self.Mannequin.Craft:SetPosition(0,0);
	self.Mannequin.Craft:SetBackground(0x41007ea0);
	self.Mannequin.Craft:SetSize(110,148);
	self.Mannequin.Craft:SetBackColor(Turbine.UI.Color(.7,0,.8,0));
	self.Mannequin.Craft:SetBlendMode(4);
	self.Mannequin.Craft:SetBackColorBlendMode(1); -- 6
	self.Mannequin.Craft:SetStretchMode(1);
	self.Mannequin.Craft:SetMouseVisible(false);

--***
	self.IsValid=function()
		return (characterListArray[self.characterIndex][9]==Turbine.Gameplay.Alignment.FreePeople)
	end

	self.LoadPanelData=function(sender, characterName)
		local tmpIndex;
		for tmpIndex=1,#characterListArray do
			if characterListArray[tmpIndex][1]==characterName then
				self.characterIndex=tmpIndex;
				if inventoryWindow~=nil and inventoryWindow.PanelShowing==self.Index then
					self:SetVisible(self:IsValid())
				end
				break;
			end
		end
		local equipIndex;
		local tmpImage;

		if (characterName==Resource[language][29].." ") then
			-- hmmm not sure WHAT to do for this case...
			-- perhaps display a big Not Applicable message
			for equipIndex=1,20 do
				-- hide the backgrounds and images
			end
		else
			if (characterName==currentCharacterName) then
				for equipIndex=1,20 do
					tmpImage=nil;
					if equipmentArray[characterName][equipIndex]~=nil then
						if equipmentArray[characterName][equipIndex][9]~=nil then
							tmpImage=equipmentArray[characterName][equipIndex][8];
						end
					end
					if tmpImage~=nil then
						self.ItemSlot[equipIndex].BackgroundImage:SetVisible(true);
						self.ItemSlot[equipIndex].BackgroundImage:SetBackground(tmpImage);
					else
						self.ItemSlot[equipIndex].BackgroundImage:SetVisible(false);
					end
					if equipmentArray[characterName][equipIndex]~=nil and equipmentArray[characterName][equipIndex][9]~=nil then
						tmpImage=equipmentArray[characterName][equipIndex][9];
					end
					if tmpImage~=nil then
						self.ItemSlot[equipIndex].Image:SetVisible(true);
						self.ItemSlot[equipIndex].Image:SetBackground(tmpImage);
					else
						self.ItemSlot[equipIndex].Image:SetVisible(false);
					end
					if equipmentArray[characterName][equipIndex]~=nil and equipmentArray[characterName][equipIndex][5]~=nil then
						self.ItemSlot[equipIndex].Name=equipmentArray[characterName][equipIndex][5];
					else
						self.ItemSlot[equipIndex].Name=nil;
					end

					-- show the backgrounds and images
					-- load the equipped items from the table
					-- set the mannequin state from the table
				end
			else
				for equipIndex=1,20 do
					tmpImage=nil
--					equipmentArray[currentCharacterName][tmpIndex]={tmpIndex,tmpItem:GetDurability(),tmpItem:GetQuality(),tmpItem:GetWearState(),tmpItem:GetName(),tmpItem:GetQuantity(),{},tmpItem:GetBackgroundImageID(),tmpItem:GetIconImageID(),tmpItem:GetQualityImageID(),tmpItem:GetShadowImageID(),tmpItem:GetUnderlayImageID(),tmpItem:GetCategory()};
					if equipmentArray[characterName]~=nil and equipmentArray[characterName][equipIndex]~=nil then
						if equipmentArray[characterName][equipIndex][9]~=nil then
							tmpImage=equipmentArray[characterName][equipIndex][8];
						else
--							tmpImage=0x41000001;
						end
					end
					if tmpImage~=nil then
						self.ItemSlot[equipIndex].BackgroundImage:SetVisible(true);
						self.ItemSlot[equipIndex].BackgroundImage:SetBackground(tmpImage);
					else
						self.ItemSlot[equipIndex].BackgroundImage:SetVisible(false);
					end
					if equipmentArray[characterName]~=nil and equipmentArray[characterName][equipIndex]~=nil and equipmentArray[characterName][equipIndex][9]~=nil then
						tmpImage=equipmentArray[characterName][equipIndex][9];
					end
					if tmpImage~=nil then
						self.ItemSlot[equipIndex].Image:SetVisible(true);
						self.ItemSlot[equipIndex].Image:SetBackground(tmpImage);
					else
						self.ItemSlot[equipIndex].Image:SetVisible(false);
					end
					if equipmentArray[characterName]~=nil and equipmentArray[characterName][equipIndex]~=nil and equipmentArray[characterName][equipIndex][5]~=nil then
						self.ItemSlot[equipIndex].Name=equipmentArray[characterName][equipIndex][5];
					else
						self.ItemSlot[equipIndex].Name=nil;
					end
				end
			end
		end
	end
-- settings for Equipped Items view, not sure whether I'm keeping this stuff though...
	self.SaveData=function()
		PatchDataSave( Turbine.DataScope.Account, "AltInventory_EquipmentLayout", equipmentLayout);
	end
	self.SizeChanged=function(sender,args)
		local newWidth=self:GetWidth()
		local newHeight=self:GetHeight()
		self.Backdrop:SetSize(newWidth,newHeight);
		self.MoveControlPanel:SetWidth(newWidth)
		self.MoveUseDefault:SetLeft((self:GetWidth()-100)/2);
		if self.oldHeight>0 and self.oldWidth>0 then
			-- reposition the mannequin relative to it's old position and move the other icons with it
-- calculate position based on centers, not on spacing?
			local oldHSpace,oldVSpace=self.oldWidth-self.Mannequin:GetWidth(),self.oldHeight-self.Mannequin:GetHeight();
			local newHSpace,newVSpace=newWidth-self.Mannequin:GetWidth(),newHeight-self.Mannequin:GetHeight();
			local newLeft,newTop=self.Mannequin:GetLeft()/oldHSpace*newHSpace,self.Mannequin:GetTop()/oldVSpace*newVSpace;
			local hOffset,vOffset=newLeft-self.Mannequin:GetLeft(),newTop-self.Mannequin:GetTop();
			local itemIndex
			for itemIndex=1,#self.ItemSlot do
				self.ItemSlot[itemIndex]:SetLeft(self.ItemSlot[itemIndex]:GetLeft()+hOffset);
				self.ItemSlot[itemIndex]:SetTop(self.ItemSlot[itemIndex]:GetTop()+vOffset);
				equipmentLayout[itemIndex][1]=self.ItemSlot[itemIndex]:GetLeft();
				equipmentLayout[itemIndex][2]=self.ItemSlot[itemIndex]:GetTop();
			end
			self.Mannequin:SetPosition(newLeft,newTop);
			equipmentLayout[0][1]=newLeft;
			equipmentLayout[0][2]=newTop;
		end
		self.oldHeight=newHeight;
		self.oldWidth=newWidth;
	end

	self.SetLanguage=function()
		self.MoveUseDefault:SetText(Resource[language][302]);
	end
end